----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    13:09:25 05/09/2010 
-- Design Name: 
-- Module Name:    test_G_sitcp - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity SiTCP_sub is
    Port ( clk : in  STD_LOGIC;
	vme_addr : out  std_logic_vector(31 downto 0);
	vme_dout : out std_logic_vector(15 downto 0);
	vme_doe : out  STD_LOGIC;
	vme_dock : out  STD_LOGIC;
	vme_doac : in  STD_LOGIC;
	vme_din : in std_logic_vector(15 downto 0);
	vme_dick : in  STD_LOGIC;
	vme_diac : out  STD_LOGIC;
	vme_length : out std_logic_vector(31 downto 0);
	vme_done : in  STD_LOGIC;
	prob: out STD_LOGIC_VECTOR(3 downto 0);

	tx_wd : out std_logic_vector(7 downto 0);
	tx_we : out  STD_LOGIC;
	tx_afull : in  STD_LOGIC;
	rx_rd : in std_logic_vector(7 downto 0);
	rx_rv : in  STD_LOGIC;
	rx_re : out  STD_LOGIC;
	close_req : in  STD_LOGIC;
	close_ack : out  STD_LOGIC;
	active : in  STD_LOGIC);
end SiTCP_sub;

architecture Behavioral of SiTCP_sub is
component fifo16k8s
  PORT (
    clk : IN STD_LOGIC;
    srst : IN STD_LOGIC;
    din : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
    wr_en : IN STD_LOGIC;
    rd_en : IN STD_LOGIC;
    dout : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
    full : OUT STD_LOGIC;
    empty : OUT STD_LOGIC
  );
END component;
component fifo128_8
  PORT (
    clk : IN STD_LOGIC;
    srst : IN STD_LOGIC;
    din : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
    wr_en : IN STD_LOGIC;
    rd_en : IN STD_LOGIC;
    dout : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
    full : OUT STD_LOGIC;
    empty : OUT STD_LOGIC
  );
END component;
	signal hl_flag, hlr_flag, dvdick, dsendf, pvdock, prx_re, auto_on, auto_do, pvdoe : STD_LOGIC;
	signal vdin : STD_LOGIC_VECTOR(15 downto 0);
	signal vhbuf : STD_LOGIC_VECTOR(7 downto 0);
	signal v_phase : STD_LOGIC_VECTOR(2 downto 0);
	signal pao : STD_LOGIC_VECTOR(1 downto 0);
	signal pvlen : STD_LOGIC_VECTOR(31 downto 0);
	signal srst, wr_en, rd_en, drd_en, full, empty, dempty, wr_on, wr_do : STD_LOGIC;
	signal end_fg, dvdone : STD_LOGIC;
	signal fdin, fdout : STD_LOGIC_VECTOR(7 downto 0);

--	signal vlenct : STD_LOGIC_VECTOR(31 downto 0);	--for test 2012 9/15
--	signal vlenbuf : STD_LOGIC_VECTOR(15 downto 0);	--for test 2012 9/15
--	signal waitct : STD_LOGIC_VECTOR(7 downto 0);	--for test 2012 9/15
begin
vme_diac <= dsendf;
vme_dock <= pvdock;
vme_length <= pvlen;
vme_doe <= pvdoe;
rx_re <= prx_re;
u1: fifo16k8s port map(clk, srst, fdin, wr_en, rd_en, fdout, full, empty);
--u1: fifo128_8 port map(clk, srst, fdin, wr_en, rd_en, fdout, full, empty);
prob(0) <= wr_en;
prob(1) <= vme_doac;
prob(2) <= rd_en;
prob(3) <= srst;
srst <= '1' when v_phase<"100" else '0';

process (CLK)
begin
if CLK='1' and CLK'event then
	dvdick <= vme_dick;
	if rd_en='1' then rd_en<='0';	end if;
	drd_en <= rd_en;
	dempty <= empty;
	dvdone <= vme_done;
	if active='1' then
		if close_req='1' then
			close_ack <= '1';
		else
			close_ack <= '0';
			if vme_dick='1' and dvdick='0' and dsendf='0' then
				vdin <= vme_din;
				dsendf <= '1';
			end if;
			if vme_doac='1' then
				if auto_on='1' then
					auto_do <= '1';
				elsif wr_on='1' then
					wr_do <= '1';
				end if;
			end if;
			if pvdock='1' then	pvdock <= '0';	end if;
			if pvdoe='1' and vme_doac='0' then
				if auto_on='0' then
					if rd_en='0' and drd_en='0' and empty='0' and dempty='0' then
						hlr_flag <= not hlr_flag;
						rd_en <= '1';
						if pvlen(23 downto 0)=X"000001" then
							vme_dout <= fdout&fdout;
							pvdock <= '1';
						elsif hlr_flag='0' then
							vhbuf <= fdout;
						else
							vme_dout <= vhbuf&fdout;
							pvdock <= '1';
						end if;
					end if;
				else
					vme_dout <= (others=>'0');
					pvdock <= '1';
					wr_on <= '0';
					wr_do <= '0';
				end if;
			end if;
			if vme_done='1' and dvdone='0' and pao="00" then	--end read operation
				end_fg <= '1';	--end read
			end if;
			if tx_afull='0' and (dsendf='1' or ((auto_do='1' or wr_do='1') and vme_done='1')) then
				tx_we <= '1';
				hl_flag <= not hl_flag;
				if hl_flag='0' then
					tx_wd <= vdin(15 downto 8);
				else
					tx_wd <= vdin(7 downto 0);
					if dsendf='1' then
						dsendf <= '0';
					else
						end_fg <= '1';	--end write
					end if;
				end if;
			else
				tx_we <= '0';
			end if;
			if rx_rv='1' then
				if v_phase<"100" then
					hlr_flag <= not hlr_flag;
					prx_re <= '1';
					if hlr_flag='0' then
						vhbuf <= rx_rd;
					else
						v_phase <= v_phase+1;
						if v_phase="000" then
							vme_addr(31 downto 16) <= vhbuf&rx_rd;
							pao <= vhbuf(7 downto 6);
							hl_flag <= '0';
						elsif v_phase="001" then
							vme_addr(15 downto 0) <= vhbuf&rx_rd;
						elsif v_phase="010" then
							pvlen(31 downto 16) <= vhbuf&rx_rd;
						elsif v_phase="011" then
							pvlen(15 downto 0) <= vhbuf&rx_rd;
							pvdoe <= '1';
							if pao(1 downto 0)="11" then
								auto_on <= '1';
							end if;
							vdin <= vhbuf&rx_rd;
						end if;
					end if;
				else
					if full='0' then
						prx_re <= '1';
						fdin <= rx_rd;
						if auto_on='0' then	--for test
							wr_en <= '1';
							wr_on <= '1';
						end if;
					else
						prx_re <= '0';
						wr_en <= '0';
					end if;
				end if;
			else
				prx_re <= '0';
				wr_en <= '0';
			end if;
		end if;
	end if;
	if active='0' or end_fg='1' then
		end_fg <= '0';
		close_ack <= '0';
		tx_we <= '0';
		prx_re <= '0';
		hl_flag <= '0';
		hlr_flag <= '0';
		v_phase <= (others=>'0');
		pvdoe <= '0';
		pvdock <= '0';
		dsendf <= '0';
		auto_on <= '0';
		auto_do <= '0';
		wr_on <= '0';
		wr_do <= '0';
		wr_en <= '0';
	end if;
end if;
end process;
end Behavioral;

